## ?q=aHR0cHM6Ly9naXRodWIuY29tL3RpY3B1L2tleWxlZHMvYXJjaGl2ZS9yZWZzL3RhZ3MvdjAuOC4wLjEuemlw

=== CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)
project (keyleds LANGUAGES C CXX)

##############################################################################
# Settings

include(GNUInstallDirs)

option(WITH_PYTHON "build python bindings" OFF)
option(WITH_KEYLEDSD "build keyledsd daemon" ON)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

##############################################################################
# Work around Qt script selecting wrong tools while cross-compiling

IF(WITH_KEYLEDSD AND CMAKE_CROSSCOMPILING)
    execute_process(COMMAND qtchooser -qt=5 -print-env
                    COMMAND grep ^QTTOOLDIR=
                    COMMAND sed s/^QTTOOLDIR=\"\\\(.*\\\)\"$/\\1/
                    OUTPUT_VARIABLE NATIVE_QT_BINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)

    set(QT_MOC_EXECUTABLE ${NATIVE_QT_BINDIR}/moc)
    add_executable(Qt5::moc IMPORTED)
    set_property(TARGET Qt5::moc PROPERTY IMPORTED_LOCATION ${QT_MOC_EXECUTABLE})
    add_executable(Qt5::rcc IMPORTED)
    set_property(TARGET Qt5::rcc PROPERTY IMPORTED_LOCATION ${NATIVE_QT_BINDIR}/rcc)
    add_executable(Qt5::qdbuscpp2xml IMPORTED)
    set_property(TARGET Qt5::qdbuscpp2xml PROPERTY IMPORTED_LOCATION ${NATIVE_QT_BINDIR}/qdbuscpp2xml)
    add_executable(Qt5::qdbusxml2cpp IMPORTED)
    set_property(TARGET Qt5::qdbuscpp2xml PROPERTY IMPORTED_LOCATION ${NATIVE_QT_BINDIR}/qdbusxml2cpp)
ENDIF(WITH_KEYLEDSD AND CMAKE_CROSSCOMPILING)

##############################################################################
# Include subprojects

add_subdirectory(libkeyleds)
add_subdirectory(keyledsctl)
IF (WITH_KEYLEDSD)
    add_subdirectory(keyledsd)
ENDIF()
IF (WITH_PYTHON)
    add_subdirectory(python)
ENDIF()

=== keyledsctl/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)
project(keyledsctl VERSION 1.0 LANGUAGES C)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror -std=c99 -D_POSIX_C_SOURCE=200112L")

##############################################################################
# Sources

# Look for header files in build directory (for config.h) and include dir
include_directories("${PROJECT_BINARY_DIR}" "include")

# List of sources
set(keyledsctl_SRCS
    src/dev_enum.c
    src/logging.c
    src/keyledsctl.c
    src/utils.c
)

##############################################################################
# Dependencies

# Choose device enumeration method depending on available packages
find_library(LIBUDEV_FOUND udev)
IF(LIBUDEV_FOUND)
    MESSAGE(STATUS "Using libudev for device enumeration")
    set(keyledsctl_SRCS ${keyledsctl_SRCS} src/dev_enum_udev.c)
    set(keyledsctl_DEPS ${keyledsctl_DEPS} udev)
ELSE(LIBUDEV_FOUND)
    MESSAGE(WARNING "libudev not found, falling back to hardcoded enumeration")
    set(keyledsctl_SRCS ${keyledsctl_SRCS} src/dev_enum_hard.c)
ENDIF(LIBUDEV_FOUND)

configure_file("include/config.h.in" "config.h")

##############################################################################
# Targets

# CLI tool
add_executable(keyledsctl ${keyledsctl_SRCS})
target_link_libraries(keyledsctl libkeyleds ${keyledsctl_DEPS})

# Installing stuff (stub)
install(TARGETS keyledsctl DESTINATION ${CMAKE_INSTALL_BINDIR})

=== keyledsd/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)
project(keyledsd VERSION 0.7.9 LANGUAGES CXX)

##############################################################################
# Options

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fPIC -fno-rtti -fvisibility=hidden -fstrict-enums -ffast-math")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Wall -Wextra -Wcast-align -Wcast-qual -Wconversion -Wsign-conversion -Wshadow -Wstrict-overflow=3")

##############################################################################
# Subtargets and data files

configure_file("config.h.in" "keyledsd_config.h")
include_directories(${PROJECT_BINARY_DIR})

add_subdirectory(common)
add_subdirectory(core)
add_subdirectory(plugins)
add_subdirectory(service)

install(DIRECTORY effects/
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/effects
        FILES_MATCHING PATTERN "*.lua")
install(DIRECTORY layouts/
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/layouts
        FILES_MATCHING PATTERN "*.xml")
install(FILES keyledsd.conf.sample keyledsd.desktop
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME})

=== libkeyleds/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)
project(libkeyleds VERSION 1.0 LANGUAGES C)
include(CheckCSourceCompiles)
include(CheckIncludeFile)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -D_POSIX_C_SOURCE=200112L -fvisibility=internal")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -Wextra -Wconversion -Wsign-conversion -Wcast-qual -Wstrict-prototypes -Wmissing-prototypes -Wshadow -Wpointer-arith")

##############################################################################
# Sources

# Look for header files in build directory (for config.h) and include dir
include_directories(BEFORE "${PROJECT_BINARY_DIR}" "include")

# List of sources
set(libkeyleds_SRCS
    src/device.c
    src/error.c
    src/feature_core.c
    src/feature_gamemode.c
    src/feature_layout.c
    src/feature_leds.c
    src/feature_reportrate.c
    src/feature_version.c
    src/hid_parser.c
    src/keys.c
    src/logging.c
    src/strings.c
)

##############################################################################
# Dependencies

# Required dependency on Linux' hidraw device
check_include_file(linux/hidraw.h HIDRAW_FOUND)
IF(NOT HIDRAW_FOUND)
    MESSAGE(SEND_ERROR "linux/hidraw.h not found -- is the target system a Linux box")
ENDIF()

# Optional Thread-local storage for error reporting
check_c_source_compiles("__thread int tls; int main() { return 0; }" GCC_THREAD_LOCAL_FOUND)
check_c_source_compiles("_Thread_local int tls; int main() { return 0; }" C11_THREAD_LOCAL_FOUND)

# Optional enhanced strerrror if available
check_c_source_compiles("#include <string.h>\nint main() { char buf[1]; return strerror_r(0, buf, 1); }"
                        POSIX_STRERROR_R_FOUND)

# Optional automatic translation of key names to/from Linux input keycodes
check_include_file(linux/input.h INPUT_CODES_FOUND)
IF(NOT INPUT_CODES_FOUND)
    MESSAGE(WARNING "linux/input.h not found, key names will not be available")
ENDIF()

configure_file("include/config.h.in" "config.h")

##############################################################################
# Targets

# Main library
add_library(libkeyleds SHARED ${libkeyleds_SRCS})
target_include_directories(libkeyleds PUBLIC "include")
set_target_properties(libkeyleds PROPERTIES POSITION_INDEPENDENT_CODE on)
set_target_properties(libkeyleds PROPERTIES PREFIX "")
set_target_properties(libkeyleds PROPERTIES VERSION ${PROJECT_VERSION})
set_target_properties(libkeyleds PROPERTIES SOVERSION ${PROJECT_VERSION_MAJOR})

install(TARGETS libkeyleds LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES include/keyleds.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== python/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)
project (python-keyleds VERSION 0.1 LANGUAGES C)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror -std=c99")

##############################################################################
# Sources

# List of sources
set(keyleds_SRCS
    keyleds.c
)

##############################################################################
# Dependencies

# Build python bindings unless disabled or dependincies are missing
find_package(PythonLibs)
IF (NOT PYTHONLIBS_FOUND)
    MESSAGE(WARNING "Python libs not found, not building python bindings")
    RETURN()
ENDIF()
set(keyleds_INCLUDES ${keyleds_INCLUDES} ${PYTHON_INCLUDE_DIRS})
set(keyleds_DEPS ${keyleds_DEPS} ${PYTHON_LIBRARIES})

find_program(CYTHON cython3 cython)
IF (NOT CYTHON)
    MESSAGE(WARNING "cython is missing, not building python bindings")
    RETURN()
ENDIF()


##############################################################################
# Commands

add_custom_command(OUTPUT keyleds.c
                   COMMAND ${CYTHON}
                   ARGS $(C_INCLUDES) -o keyleds.c ${CMAKE_CURRENT_SOURCE_DIR}/keyleds.pyx
                   MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/keyleds.pyx
                   DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/keyleds.pxd
                   COMMENT "Generating C source keyleds.c")

##############################################################################
# Targets

# Python bindings
add_library(keyleds MODULE ${keyleds_SRCS})
set_target_properties(keyleds PROPERTIES PREFIX "")
target_include_directories(keyleds PRIVATE ${keyleds_INCLUDES})
target_link_libraries(keyleds libkeyleds ${keyleds_DEPS})

install(TARGETS keyleds LIBRARY DESTINATION lib)

=== keyledsd/common/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)
include(CheckCSourceCompiles)

##############################################################################
# Options

if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL x86_64 OR ${CMAKE_SYSTEM_PROCESSOR} STREQUAL i686)
    set(KEYLEDSD_USE_SSE2 1)
    set(KEYLEDSD_USE_AVX2 1)
endif()

##############################################################################
# Sources

include_directories("${CMAKE_CURRENT_BINARY_DIR}")

set(common_SRCS
    src/KeyDatabase.cxx
    src/RenderTarget.cxx
    src/accelerated.c
    src/accelerated_plain.c
    src/colors.cxx
    src/utils.cxx
)
if(KEYLEDSD_USE_SSE2)
    set(common_SRCS ${common_SRCS} src/accelerated_sse2.c)
    set_source_files_properties("src/accelerated_sse2.c"
                                PROPERTIES COMPILE_FLAGS "-msse2")
endif()
if(KEYLEDSD_USE_AVX2)
    set(common_SRCS ${common_SRCS} src/accelerated_avx2.c)
    set_source_files_properties("src/accelerated_avx2.c"
                                PROPERTIES COMPILE_FLAGS "-mavx2")
endif()

##############################################################################
# Feature detection

check_c_source_compiles("int main() {
  return __builtin_cpu_supports(\"sse2\");
}" HAVE_BUILTIN_CPU_SUPPORTS)

check_c_source_compiles("
int foo_actual() { return 0; }
static int (*resolve_foo(void))()  { return foo_actual; }
int foo() __attribute__((ifunc(\"resolve_foo\")));
int main() { return foo(); }
" HAVE_IFUNC_ATTRIBUTE)

configure_file("include/config.h.in" "config.h")

##############################################################################
# Targets

add_library(common SHARED ${common_SRCS})
target_include_directories(common PUBLIC "include")
target_link_libraries(common PRIVATE gcc_s gcc) # Work around a bug in gcc

set_target_properties(common PROPERTIES PREFIX "keyleds_")
set_target_properties(common PROPERTIES VERSION ${PROJECT_VERSION})
set_target_properties(common PROPERTIES SOVERSION ${PROJECT_VERSION_MAJOR})

install(TARGETS common LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== keyledsd/core/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)

##############################################################################
# Sources

# Look for header files in build directory (for config.h)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

# List of sources
set(core_SRCS
    src/keyledsd/Configuration.cxx
    src/keyledsd/Device.cxx
    src/keyledsd/EffectManager.cxx
    src/keyledsd/LayoutDescription.cxx
    src/keyledsd/RenderLoop.cxx
    src/tools/AnimationLoop.cxx
    src/tools/DynamicLibrary.cxx
    src/tools/Paths.cxx
    src/tools/XWindow.cxx
    src/tools/YAMLParser.cxx
    src/logging.cxx
)

set(core_DEPS ${CMAKE_DL_LIBS})

##############################################################################
# Dependencies

find_package(Threads REQUIRED)
set(core_DEPS ${core_DEPS} ${CMAKE_THREAD_LIBS_INIT})

find_library(LIBYAML yaml)
IF(NOT LIBYAML)
    MESSAGE(SEND_ERROR "libyaml is required for keyledsd")
ENDIF(NOT LIBYAML)
set(core_DEPS ${core_DEPS} ${LIBYAML})

find_package(LibXml2 REQUIRED)
include_directories(${LIBXML2_INCLUDE_DIR})
set(core_DEPS ${core_DEPS} ${LIBXML2_LIBRARIES})

find_package(X11)
include_directories(${X11_Xlib_INCLUDE_PATH} ${X11_Xinput_INCLUDE_PATH})
set(core_DEPS ${core_DEPS} ${X11_LIBRARIES} ${X11_Xinput_LIB})

configure_file("include/config.h.in" "config.h")

##############################################################################
# Targets

add_library(core STATIC ${core_SRCS})
target_include_directories(core PUBLIC "include")
target_link_libraries(core common ${core_DEPS})

=== keyledsd/plugins/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)

##############################################################################
# Settings

option(WITH_LUA "build LUA scripting engine" ON)

##############################################################################
# Sources

# Look for header files in build directory (for config.h) and include dir
include_directories("${CMAKE_CURRENT_BINARY_DIR}" "include")

##############################################################################
# Dependencies

find_package(PkgConfig)

if(WITH_LUA)
    pkg_search_module(LUA REQUIRED luajit lua-5.3 lua-5.2)
endif(WITH_LUA)

##############################################################################
# Targets

foreach(module breathe feedback fill stars wave)
    add_library(fx_${module} MODULE src/${module}.cxx)
    target_link_libraries(fx_${module} common)
    set_target_properties(fx_${module} PROPERTIES PREFIX "")
    set(module_TARGETS ${module_TARGETS} fx_${module})
endforeach()


IF(WITH_LUA)
    add_library(fx_lua MODULE
        src/lua/Environment.cxx
        src/lua/LuaEffect.cxx
        src/lua/lua_Interpolator.cxx
        src/lua/lua_Key.cxx
        src/lua/lua_KeyDatabase.cxx
        src/lua/lua_KeyGroup.cxx
        src/lua/lua_RGBAColor.cxx
        src/lua/lua_RenderTarget.cxx
        src/lua/lua_Thread.cxx
        src/lua/lua_common.cxx
        src/lua/lua_types.cxx
        src/lua.cxx
    )
    target_compile_options(fx_lua PRIVATE ${LUA_CFLAGS_OTHER})
    target_include_directories(fx_lua PRIVATE ${LUA_INCLUDE_DIRS})
    target_link_libraries(fx_lua common ${LUA_LIBRARIES})
    set_target_properties(fx_lua PROPERTIES PREFIX "")
    set(module_TARGETS ${module_TARGETS} fx_lua)
ENDIF(WITH_LUA)

##############################################################################
# Installing stuff

install(TARGETS ${module_TARGETS} DESTINATION ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME})
IF(WITH_LUA)
    install(DIRECTORY effects/
            DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/effects
            FILES_MATCHING PATTERN "*.lua")
ENDIF(WITH_LUA)

=== keyledsd/service/CMakeLists.txt ===
# Keyleds -- Gaming keyboard tool
# Copyright (C) 2017 Julien Hartmann, juli1.hartmann@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.0)

##############################################################################
# Options

option(NO_DBUS "Do not compile DBus support" OFF)

##############################################################################
# Sources

# Look for header files in build directory (for config.h) and include dir
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

# List of sources
set(service_SRCS
    src/device/Logitech.cxx
    src/effect/EffectService.cxx
    src/effect/StaticModuleRegistry.cxx
    src/tools/DeviceWatcher.cxx
    src/tools/Event.cxx
    src/tools/FileWatcher.cxx
    src/tools/XContextWatcher.cxx
    src/tools/XInputWatcher.cxx
    src/DeviceManager.cxx
    src/DisplayManager.cxx
    src/Service.cxx
    src/main.cxx
)

IF(NOT NO_DBUS)
    set(service_SRCS ${service_SRCS}
        src/dbus/DeviceManager.cxx
        src/dbus/Service.cxx
    )
ENDIF()

##############################################################################
# Dependencies

find_library(LIBUDEV udev)
IF(NOT LIBUDEV)
    MESSAGE(SEND_ERROR "libudev is required for keyledsd")
ENDIF(NOT LIBUDEV)
set(service_DEPS ${service_DEPS} ${LIBUDEV})

find_package(PkgConfig REQUIRED)
pkg_check_modules(LIBUV REQUIRED libuv)
include_directories(${LIBUV_INCLUDE_DIRS})
set(service_DEPS ${service_DEPS} ${LIBUV_LIBRARIES})

IF(NOT NO_DBUS)
    pkg_check_modules(LIBSYSTEMD REQUIRED libsystemd)
    include_directories(${LIBSYSTEMD_INCLUDE_DIRS})
    set(service_DEPS ${service_DEPS} ${LIBSYSTEMD_LIBRARIES})
ENDIF()

configure_file("include/config.h.in" "config.h")

##############################################################################
# Targets

# Binary
add_executable(${PROJECT_NAME} ${service_SRCS})
target_compile_definitions(${PROJECT_NAME} PRIVATE KEYLEDSD_MODULES_STATIC=1)
target_include_directories(${PROJECT_NAME} PRIVATE include)
target_link_libraries(${PROJECT_NAME} common core libkeyleds ${service_DEPS})

##############################################################################
# Installing stuff
install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
keyleds (0.8.0.1-1) unstable; urgency=medium

  * Updated upstream to v0.8.0.1.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Fri, 01 Feb 2019 22:34:32 +0000

keyleds (0.8.0-1) unstable; urgency=medium

  * Updated upstream to v0.8.0.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Fri, 01 Feb 2019 20:46:17 +0000

keyleds (0.7.9-1) unstable; urgency=medium

  * Updated upstream to v0.7.9.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sat, 17 Nov 2018 15:04:10 +0000

keyleds (0.7.8.1-1) unstable; urgency=medium

  * Updated upstream to v0.7.8.1.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sun, 16 Sep 2018 17:16:36 +0000

keyleds (0.7.8-1) unstable; urgency=medium

  * Updated upstream to v0.7.8.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sun, 16 Sep 2018 13:58:27 +0000

keyleds (0.7.7-1) unstable; urgency=medium

  * Updated upstream to v0.7.7.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Wed, 29 Aug 2018 14:08:18 +0000

keyleds (0.7.6-1) unstable; urgency=medium

  * Updated upstream to v0.7.6.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sat, 28 Jul 2018 13:25:12 +0000

keyleds (0.7.5-1) unstable; urgency=medium

  * Updated upstream to v0.7.5.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Thu, 22 Mar 2018 22:47:41 +0000

keyleds (0.7.4-1) unstable; urgency=medium

  * Updated upstream to v0.7.4.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sun, 28 Jan 2018 14:02:47 +0000

keyleds (0.7.3-1) unstable; urgency=medium

  * Updated upstream to v0.7.3.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sat, 27 Jan 2018 00:05:02 +0000

keyleds (0.7.1-1) unstable; urgency=medium

  * Updated upstream to v0.7.1.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Wed, 15 Nov 2017 13:00:10 +0000

keyleds (0.7.0-1) unstable; urgency=medium

  * Updated upstream to v0.7.0.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sat, 27 Oct 2017 12:19:42 +0000

keyleds (0.6.2-1) unstable; urgency=medium

  * Updated upstream to v0.6.2.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sat, 14 Oct 2017 19:07:33 +0000

keyleds (0.6.1-1) unstable; urgency=medium

  * Updated upstream to v0.6.1.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sun, 08 Oct 2017 22:02:01 +0000

keyleds (0.6.0-1) unstable; urgency=medium

  * Updated upstream to v0.6.0.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sat, 07 Oct 2017 21:30:52 +0000

keyleds (0.5.0-1) unstable; urgency=medium

  * Updated upstream to v0.5.0.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Sun, 24 Sep 2017 19:42:54 +0000

keyleds (0.4.3-1) unstable; urgency=medium

  * Updated upstream to v0.4.3.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Thu, 21 Sep 2017 01:20:01 +0000

keyleds (0.4.2-1) unstable; urgency=medium

  * Updated upstream to v0.4.2.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Fri, 15 Sep 2017 16:09:29 +0000

keyleds (0.4.1-1) unstable; urgency=medium

  * Updated upstream to v0.4.1.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Tue, 29 Aug 2017 09:17:51 +0000

keyleds (0.4-1) unstable; urgency=medium

  * Updated upstream to v0.4.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Mon, 07 Aug 2017 14:20:12 +0000

keyleds (0.3.2-1) unstable; urgency=medium

  * Updated udev rules to use user access instead of ubuntu-specific plugdev
    group.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Wed, 02 Aug 2017 14:04:57 +0000

keyleds (0.3.1-1) unstable; urgency=medium

  * Fixed build error on 32-bit architectures.
  * Enabled MMX/SSE2 acceleration on i686

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Tue, 01 Aug 2017 23:00:43 +0000

keyleds (0.3-2) unstable; urgency=medium

  * Fixed build dependencies

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Tue, 01 Aug 2017 19:23:12 +0000

keyleds (0.3-1) unstable; urgency=medium

  * Refactored layout loading
  * Added wave plugin.

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Tue, 01 Aug 2017 16:25:39 +0000

keyleds (0.2-1) unstable; urgency=medium

  * Initial release with keyledsd (Closes: #868953)

 -- Julien Hartmann <juli1.hartmann@gmail.com>  Tue, 25 Jul 2017 16:22:14 +0000

=== debian/control ===
Source: keyleds
Section: utils
Priority: optional
Maintainer: Julien Hartmann <juli1.hartmann@gmail.com>
Build-Depends: debhelper (>=10), cmake, pkg-config, linux-libc-dev, libudev-dev, libx11-dev, libxi-dev, libxml2-dev, libyaml-dev, libluajit-5.1-dev, libuv1-dev, libsystemd-dev
Standards-Version: 3.9.8
Homepage: https://github.com/spectras/keyleds
#Vcs-Git: https://github.com/spectras/keyleds.git

Package: keyleds
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Logitech Keyboard per-key lighting control
 Userspace service for Logitech keyboards with per-key RGB LEDs.
 The following features are supported:
  - Flexible per-application RGB settings with key groups.
  - Can react to window title changes, switching profiles based on current
    webpage in browser or open file extension in editors.
  - Native animation plugins: fixed colors, keypress feedback, breathe, wave,
    stars.
  - Build your effects using LUA scripting.
  - Several plugins can be active at once, and composited with alpha blending
    to build complex effects.
  - Systemd session support, detecting user switches so multiple users can use
    the service without them fighting over keyboard control.
  - DBus interface for scripting.

Package: keyleds-dev
Architecture: any
Depends: keyleds, ${misc:Depends}
Description: Logitech Keyboard per-key lighting control - headers
 Development headers for the library implementing Logitech protocol.
 The following features are supported:
  - Inspection of device capabilities and led configuration.
  - Individual key led control (set and get).
  - Translation between led identifiers and keycodes.
  - Game-mode configuration
  - Report rate configuration

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_STRIP  = -O2
export DEB_CXXFLAGS_MAINT_STRIP  = -O2
export DEB_CFLAGS_MAINT_APPEND  = -Os
export DEB_CXXFLAGS_MAINT_APPEND  = -Os
LUA_ARCHS = amd64 arm64 armhf x86

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_LUA=$(if $(filter $(DEB_TARGET_ARCH),$(LUA_ARCHS)),1,0)

override_dh_install:
	dh_install
	install -m 644 -D keyledsd/keyledsd.conf.sample debian/keyleds/etc/keyledsd.conf
	install -d debian/keyleds/etc/xdg/autostart
	ln -s /usr/share/keyledsd/keyledsd.desktop debian/keyleds/etc/xdg/autostart/
	install -d debian/keyleds/lib/udev/rules.d
	cp debian/keyleds/usr/share/keyledsd/logitech.rules debian/keyleds/lib/udev/rules.d/70-logitech-hidpp.rules

=== debian/watch ===
version=3
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/keyleds-$1\.tar\.gz/, \
      pgpsigurlmangle=s/archive\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/" \
  https://github.com/spectras/keyleds/releases .*/v?(\d\S+)\.tar\.gz
